<?PHP  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
//------------------------------------------------------------------------------

include( "../mlLibrary.php" );
include( "../reportes/fpdf/fpdf.php" );

use CodeIgniter\Files\File;


class VriReports extends FPDF
{
	public $LeftMargin = 17;
	public $RightMargin = 196;
	//-------------------------------------------------------------------------------------------
	function Header()
	{
		//$this->Image('../../absmain/imgs/unap.png', $this->LeftMargin,  10, 20);
		//$this->Image('../../absmain/imgs/vri.png' , $this->RightMargin-19, 10, 20);

		$this->Ln(1);
		$this->SetFont('Arial','B',10);
		$this->Cell( 177, 6, toUTF(" PUNO"), 0, 1,'C',0);

		$this->SetFont('Arial','B',13);
		$this->SetTextColor(140,140,140);
		$this->Cell( 177, 6, toUTF("ABC"), 0, 1,'C',0);

		$this->SetTextColor(0,0,0);
		$this->SetFont('Arial','',7);
		$this->Cell( 177, 6, toUTF("Puno"), 0, 1,'C',0);

		$this->Line( $this->LeftMargin, 35, $this->RightMargin, 35 );
		$this->Ln(12);
	}
	//-------------------------------------------------------------------------------------------
	// Page footer
	//-------------------------------------------------------------------------------------------
	function Footer()
	{
		// Position at 1.5 cm from bottom
		$this->SetY(-19);
		$this->SetFont('Arial','I',7);

		// Page number
		$this->Line( $this->LeftMargin, 280, $this->RightMargin, 280 );
		$this->Cell( 0, 9, toUTF("Plataforma de Investigación y Desarrollo") ,0,0,'L');
		$this->Cell( 0, 9, toUTF("Página - ".$this->PageNo()),0,0,'R');
	}
}


class Admin extends CI_Controller {

    public function __construct()
    {
        parent::__construct();
        $this->load->model("ado");
        $this->load->library("session");
        $this->load->library("email");
    }
    //------------------------------------------------------------------------------
    public function index()
    {
        // panel de control
        //---------------------
        // + Inscritos > Validación (Marcar como Asistente, Ponente, Organizador)
        // + Certificados > Grupo Asistente, Organizador, Ponente, Apoyo

        // + Asistencias > Reportes PDF [ok]
        // + Asistencias > Reportes PDF [ok]
        // + Creacion de Horarios
        // + Creacion de Grupos

        $this->load->view("webHead");
        $this->load->view("admLogin");
    }
    //------------------------------------------------------------------------------
    public function verPanel()
    {
        $this->onAreWeLogged();

        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view("admPanel");
        $this->load->view("webFoot");
    }
    //------------------------------------------------------------------------------
    public function listar()
    {
        $data = $this->onAreWeLogged();

        $event = mlSecureRequest('event', 0 );
        $grupo = mlSecureRequest('grupo', 0 );


        //=========================================
        // Control Temporal en un solo evento
        //=========================================
        $filtro = null;
        if( $data["leveladm"] == 6 ){
            $event = 25;
            $filtro = "Id=$event";
        }
        //=========================================



        // seleccionar primer grupo activo
        $tblGrupos = $this->ado->getSnapView( 'Grupos', "IdEvento=$event" );
        if( $event != 0 && $grupo == 0 && $tblGrupos->num_rows()>0 ) {
            $row       = $tblGrupos->row();
            $grupo     = $row->Id;
        }


        $arg = array(
            'leveladm' => $data["leveladm"],
            'event'    => $event,
            'grupo'    => $grupo,
            'tGrupos'  => $tblGrupos,
            'tEventos' => $this->ado->getSnapView( 'Eventos', $filtro, 'ORDER BY Id DESC' ),
            'tPreinsc' => $this->ado->getSnapView( 'vwInscritos', "IdEvento=$event AND Activo=0" ), // todos grupos
            'tInscrit' => $this->ado->getSnapView( 'vwInscritos', "IdGrupo=$grupo AND Activo=1" ),
            'TotalIns' => $this->ado->getTotalRows( 'vwInscritos', array('IdEvento'=>$event,'Activo'=>1) )
        );

        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view("admListar", $arg );
        $this->load->view("webFoot");
    }
    //------------------------------------------------------------------------------
    public function asists()
    {
        // el marcado de asistencias se hará con DOM Ajax
        // se requiere velocidad de procesamiento
        $data = $this->onAreWeLogged();

        $event = mlSecureRequest('event', 0 );
        $grupo = mlSecureRequest('grupo', 0 );
        $horar = mlSecureRequest('horar', 0 );



        //=========================================
        // Control Temporal en un solo evento
        //=========================================
        $filtro = null;
        if( $data["leveladm"] == 6 ){
            $event = 25;
            $filtro = "Id=$event";
        }
        //=========================================


        // if $event==0 Then Ev=FindFirst->Id

        // seleccionar primer grupo activo
        $tblGrupos = $this->ado->getSnapView( 'Grupos', "IdEvento=$event" );
        if( $event != 0 && $grupo == 0 && $tblGrupos->num_rows()>0 ) {
            $row       = $tblGrupos->row();
            $grupo     = $row->Id;
        }

        $tblHorars = $this->ado->getSnapView( 'Horarios', "IdEvento=$event" );
        if( $horar == 0 && $tblHorars->num_rows()>0 ) {
            $row       = $tblHorars->row();
            $horar     = $row->Id;
        }

        // OJO: los combos deben poner <HIJO.value=0;>
        $arg = array(
            'leveladm' => $data["leveladm"],
            'event'    => $event,
            'grupo'    => $grupo,
            'horar'    => $horar,
            'tGrupos'  => $tblGrupos,
            'tHorars'  => $tblHorars,
            'tEventos' => $this->ado->getSnapView( 'Eventos', $filtro, 'ORDER BY Id DESC' ),
            'tAsisten' => null, //$this->ado->getSnapView( 'vwMarcarAsistens', "IdEvento=$event AND IdGrupo=$grupo AND IdHorario=$horar" )
        );

        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view("admAsists", $arg );
        $this->load->view("webFoot");
    }
    //------------------------------------------------------------------------------


    public function reports() {

        $arg = array(
            'tEventos' => $this->ado->getSnapView( 'Eventos', null, 'ORDER BY Id DESC' ),
            'tEscuelas' => $this->ado->getSnapView( 'dicCarreras', null, 'ORDER BY Id DESC' )
        );
        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view("admReports",$arg);
        $this->load->view("webFoot");
    } 
    
    public function seeReportall()
    {
//        $this->onAreWeLogged();

        $idevent = mlSecureRequest('event', 0 );

        // no falla
        $Evento = $this->ado->getOneField( "Eventos", 'Titulo', "Id=$idevent" );
        //$Carrer = $this->ado->reposOneField( "dicCarreras", 'Nombre', "Id=$idcarre" );

        $this->load->view("admRepAsists", array(
            'Evento' => $Evento,
            'Carrer'=> null,
            'tAsistentes' => $this->ado->getSnapView('vwRepAsistencias',"IdEvento=$idevent ORDER BY IdProced, DatosPers")
        ));
    }
    
    public function seeReport()
    {
//        $this->onAreWeLogged();

        $idevent = mlSecureRequest('event', 0 );
        $idcarre = mlSecureRequest('carrer', 0 );

        // no falla
        $Evento = $this->ado->getOneField( "Eventos", 'Titulo', "Id=$idevent" );
        $Carrer = $this->ado->reposOneField( "dicCarreras", 'Nombre', "Id=$idcarre" );
        if($Carrer==null){
            $Carrer = 0;
        }
        $this->load->view("admRepAsists", array(
            'Evento' => $Evento,
            'Carrer' => $Carrer,
            'tAsistentes' => $this->ado->getSnapView('vwRepAsistencias',"IdEvento=$idevent AND IdCarrera=$idcarre ORDER BY IdProced, DatosPers")
        ));

        /*
        $table = $this->ado->getSnapView('Eventos', "Id=$event");
        if( $table->num_rows() == 0 ){
            redirect(base_url());
        }
        $temp=1;
        $inscritos=$this->ado->getSnapView('Inscritos',"IdEvento=$event");
        echo "$row->Titulo<br>";
        echo "Lista de Asistente de la carrera $carrera<br>";
        foreach($inscritos->result() as $row){
            
            $inscrito=$row->IdPersona;
             
            $tblAsistencia=$this->ado->getSnapView('Asistencias',"IdInscrip=$inscrito");
            if($tblAsistencia->num_rows()>0){
                foreach($tblAsistencia->result() as $row2){
                    $asistente=$row2->Id;
                    $dataAsistente=$this->ado->getSnapView('Personas',"Id=$asistente AND IdCarrera=$carrera");
                    if($dataAsistente->num_rows()!=0){
                        foreach($dataAsistente->result() as $row3){
                            echo "$temp - $row3->Id - $row3->Apellidos $row3->Nombres <br>";
                            $temp=$temp+1;
                        }
                    }
                }
            }
        }
        */
    }
    //------------------------------------------------------------------------------
    public function editAsis()
    {
        $idInscr = mlSecureRequest("idp");
        $idGrupo = mlSecureRequest("grupox");

        $dni    = mlSecureRequest("dni");
        $nombes = mlSecureRequest("nombes");
        $apells = mlSecureRequest("apells");
        //-------------------------------------------------------------------
        $table = $this->ado->getSnapView( "Personas", "DNI = '$dni'" );
        $row = $table->row();
        $this->ado->Update( 'Personas', array(
                'DNI' => $dni,
                'Nombres' => $nombes,
                'Apellidos' => $apells
            ), $row->Id );

        //-------------------------------------------------------------------
        $this->ado->Update( 'Inscritos', array(
                'IdGrupo' => $idGrupo,
            ), $idInscr );

        // veamos como lo hace
        //echo "<script> history.back(); history.reload() </script>";
        redirect( "admin/listar" );
    }
    //------------------------------------------------------------------------------
    public function pdfLista()
    {
        $this->onAreWeLogged();

        $event = mlSecureRequest( "e" );
        $grupo = mlSecureRequest( "g" );

        $pdf = new VriReports();
        $pdf->SetMargins(18, 13, 18);
        $pdf->AddPage();
        //-------------------------------------------------
        $tgrupo = $this->ado->getSnapView( 'vwGrupos', "Id=$grupo" ); // IdEvento=$event
        $row = $tgrupo->row();

        $nro = 1;
        $siz = array( 10, 27, 103, 37 );

        $pdf->SetFont('Arial','B',11);
        $pdf->MultiCell( 174, 5.8, toUTF($row->NombEvento), 0, 'C' );
        $pdf->Ln(3);

        $pdf->SetFillColor(227,227,255);
        $pdf->SetDrawColor(50,90,110);

        $pdf->SetFont('Arial','B',9);
        $pdf->Cell( 50, 7, "GRUPO", 1, 0, 'C' );
        $pdf->Cell( 127, 7, toUTF($row->NombGrupo), 1, 0, 'C', 1 );
        $pdf->Cell( 2, 10, "", 0, 1 );

        $tasist = $this->ado->getSnapView( 'vwMarcarAsistens', "IdGrupo=$grupo", "GROUP BY DatosPers" ); // IdEvento=$event

        $pdf->SetFont('Arial','',11);
        foreach( $tasist->result() as $row )
        {
            $withBg = ($nro%2)?false:true;
            $pdf->Cell( $siz[0], 12, $nro, 1, 0,'C', $withBg);
            $pdf->Cell( $siz[1], 12, toUTF($row->DNI), 1, 0,'C', $withBg);
            $pdf->Cell( $siz[2], 12, toUTF(" ".$row->DatosPers), 1, 0,'L', $withBg);
            $pdf->Cell( $siz[3], 12, "", 1, 0,'C', $withBg);
            $pdf->Cell( 2, 12, "", 0, 1);
            $nro = $nro + 1;
        }
        //-------------------------------------------------
        $pdf->SetDisplayMode('real');
        $pdf->Output();
    }
    //------------------------------------------------------------------------------
    public function certis()
    {
        $this->onAreWeLogged();

        $event = mlSecureRequest('event', 0 );
        $grupo = mlSecureRequest('grupo', 0 );

        $filtroGrupos = "IdEvento=$event" . (($grupo)? " AND IdGrupo=$grupo" : "");

        $arg = array(
            'event'    => $event,
            'grupo'    => $grupo,
            'tGrupos'  => $this->ado->getSnapView( 'Grupos', "IdEvento=$event" ),
            'tEventos' => $this->ado->getSnapView( 'Eventos', null, 'ORDER BY Id DESC' ),
            'tAsisten' => $this->ado->getSnapView( 'vwInscritos', "IdEvento=$event", "ORDER BY DatosPers" ), //$this->ado->getSnapView( 'vwRepAsistencias', $filtroGrupos ),
            'tCertifs' => $this->ado->getSnapView( 'vwCertificas', "IdEvento=$event", "ORDER BY IdCert" ),
            'tOrganiz' => $this->ado->getSnapView( 'vwCertificas', "IdEvento=$event AND TipoCerti>1", "ORDER BY TipoCerti" )
        );

        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view("admCertis", $arg );
        $this->load->view("webFoot");
    }
    
    
    
    
    
    
    public function registarc()
    {
        $this->onAreWeLogged();

        $event = mlSecureRequest('event', 0 );
        $grupo = mlSecureRequest('grupo', 0 );

        $filtroGrupos = "IdEvento=$event" . (($grupo)? " AND IdGrupo=$grupo" : "");

        $arg = array(
            'event'    => $event,
            'grupo'    => $grupo,
            'tGrupos'  => $this->ado->getSnapView( 'Grupos', "IdEvento=$event" ),
            'tEventos' => $this->ado->getSnapView( 'Eventos', null, 'ORDER BY Id DESC' ),
            'tAsisten' => $this->ado->getSnapView( 'vwInscritos', "IdEvento=$event", "ORDER BY DatosPers" ), //$this->ado->getSnapView( 'vwRepAsistencias', $filtroGrupos ),
            'tCertifs' => $this->ado->getSnapView( 'vwCertificas', "IdEvento=$event", "ORDER BY IdCert" ),
            'tOrganiz' => $this->ado->getSnapView( 'vwCertificas', "IdEvento=$event AND TipoCerti>1", "ORDER BY TipoCerti" )
        );

        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view("creaCurso", $arg );
        $this->load->view("webFoot");
    }
    
    public function execAgregaCurso()
    {
        $this->onAreWeLogged();
        
        $validationRule = [
            'certificado' => [
                'label' => 'Image File',
                'rules' => 'uploaded[userfile]'
                    . '|is_image[userfile]'
                    . '|mime_in[userfile,image/jpg,image/jpeg,image/gif,image/png,image/webp]',
            ],
        ];
        if (! $this->validate($validationRule)) {
            $data = ['errors' => $this->validator->getErrors()];
            print_r($data);
        }
        
        $img = $this->request->getFile('certificado');
        
        print_r($img);

        if (! $img->hasMoved()) {
            $filepath = 'includefile/curs/'.'uploads/'.$img->store();
            $data = ['uploaded_flleinfo' => new File($filepath)];
            print_r($data);
        } else {
            $data = ['errors' => 'The file has already been moved.'];
            print_r($data);
        }
        
        

        $activo = 1;
        $gratis = 1;
        $idEmp = 11;
        $alias = "";
        $titulo = mlSecurePost("titulo");
        $subtitulo = "";
        $contenido = $titulo;
        $fecha = "";
        $formato = "";
        $filtro = "";
        $imageFile ="includefile/curs/"."hola".".jpg";
        $json = "";
        $fechaReg=date("Y-m-d");
        
            $this->ado->Insert("Eventos", array(
                'Activo' => $activo,
                'Gratis' => $gratis,
                'IdEmp' => $idEmp,
                'Alias' => $alias,
                'Titulo' => $titulo,
                'SubTitulo' => $subtitulo,
                'Contenido' => $contenido,
                'Fecha' => $fecha,
                'Formato' => $formato,
                'Filtro' => $filtro,
                'ImageFile' => $imageFile,
                'JSON' => $json,
                'FechReg' => $fechaReg,
            ));

        redirect( "admin/registarc" );
    }


    
    
    

    public function execAgrega()
    {
        $this->onAreWeLogged();

        $evnt = mlSecurePost("evento");
        $pers = mlSecurePost("idpers");
        $tipo = mlSecurePost("tipo");
        $mini = mlSecurePost("mini");

        $table = $this->ado->getSnapView( "Certificados", "IdEvento=$evnt AND IdPersona=$pers AND Tipo=$tipo AND MiniCur=$mini" );
        if( $table->num_rows() == 0 )
        {
            $newOrder = $this->ado->getOneField( "Certificados", 'Orden', "IdEvento=$evnt ORDER BY Orden DESC" );
            $codePatt = $this->ado->getOneField( "Eventos", 'Formato', "Id=$evnt" );
            $codeGene = sprintf( $codePatt, $newOrder + 1 );

            $this->ado->Insert("Certificados", array(
                'IdEvento'  => $evnt,
                'IdPersona' => $pers,
                'MiniCur'   => $mini,
                'Tipo'      => $tipo,
                'Orden'     => $newOrder + 1,
                'Fecha'     => mlCurrentDate(),
                'Codigo'    => $codeGene
            ));

            // search and send mail
            //$this->correoCerti( $pers, $codeGene );
        }

        redirect( "admin/certis?event=$evnt" );
    }


    function mlSendMail( $destino, $titulo, $mensaje )
    {
        $mensaje  = base64url_encode( $mensaje );
        ?>
        <script src="<?=base_url()?>includefile/lightajax.js"></script>
        <!-- area de Ajax VRI -->
        <script>
            jVRI.ajax({
                url  : "<?=base_url()?>includefile/maileventos.php",
                data : "x=<?=$destino?>&y=<?=$titulo?>&z=<?=$mensaje?>&k=1",
                success: function( res ){
                    alert( res );
                    window.close();
                }
            });
        </script>
        <?php
        /*
        $piefinal = "<b>Plataforma y Desarrollo</b><br>".
            "Vicerrectorado de Investigaci&oacute;n - UNA Puno 2016<br>".
            "<small>Av. Sesquicentenario No 1150 - Puno (051) 599430</small>";

        $mensaje = $mensaje . $piefinal;

        $cabeceras = "MIME-Version: 1.0\r\n" .
            "Content-type: text/html; charset='ISO-8859-1'\r\n" .
            "From: cursosevs@vriunap.pe\r\n" .
            "Reply-To: Usuario <".$destino.">\r\n" .
            "X-Mailer: PHP/" . phpversion();

        mail( $destino, $titulo, $mensaje, $cabeceras );
        //echo "<br>msg: $mensaje  <br>head: $cabeceras ";
        */
    }



    // invocado por JS DOM
    function javaCerti()
    {
        $this->onAreWeLogged();

        $evnt  = mlSecurePost("e");
        $pers  = mlSecurePost("p");
        $inscr = mlSecurePost("i");
        $tipo  = mlSecurePost("t");
        if( !$evnt or !$pers ) return;

        $table = $this->ado->getSnapView( "Certificados", "IdEvento=$evnt AND IdInscrip=$inscr AND IdPersona=$pers AND Tipo=$tipo" );
        if( $table->num_rows() == 0 )
        {
            $newOrder = $this->ado->getOneField( "Certificados", 'Orden', "IdEvento=$evnt ORDER BY Orden DESC" );
            $codePatt = $this->ado->getOneField( "Eventos", 'Formato', "Id=$evnt" );
            $codeGene = sprintf( $codePatt, $newOrder + 1 );

            $this->ado->Insert("Certificados", array(
                'IdEvento'  => $evnt,
                'IdPersona' => $pers,
                'IdInscrip' => $inscr,
                'IdGrupo'   => 0,
                'MiniCur'   => 0,
                'Tipo'      => $tipo,
                'Orden'     => $newOrder + 1,
                'Fecha'     => mlCurrentDate(),
                'Codigo'    => $codeGene
            ));

            // search and send mail, manual por boton
            //$this->correoCerti( $pers, $codeGene );

            echo $codeGene;
            exit;
        }
        echo "err";
    }
    
    function javaEnvia()
    {
        $this->onAreWeLogged();
        
        $idinsc = mlSecureRequest("id");
        $table = $this->ado->getSnapView( "vwInscripciones", "Id=$idinsc" );
        
        $row = $table->row();
        
        if( ! strlen($row->Certi) ){
            echo "No se ha generado";
            return;
        }
            
        $linkCerti = "http://vriunap.pe/cursos/?qr=$row->Certi";
        $mensaje = "<h2>Saludos<br></h2>" 
                     . "Esta es la confirmación de su <b>Certificado Electrónico VRI</b> " 
                     . "en la Plataforma de <b>Cursos y Eventos VRI</b>. <br><br> "
                     . "Curso : <b>$row->Titulo</b> <br> "
                     . "Apellidos y Nombres: $row->DatosPers <br>"
                     . "Horario : <b> $row->Grupo </b> <br><br> " 
                     . "Para ver su Certificado Electrónico:  <a href='$linkCerti'>CLICK AQUI</a> <br><br><br>"
                    ;

        $titulo   = 'Certificado Electronico VRI';
        
        echo "<blockquote>";
        echo $titulo;
        echo $mensaje;
        echo "</blockquote>";
        
        $this->mlSendMail( $row->Correo, $titulo, $mensaje );
    }


    // invocado por JS DOM
    function javaAsistens()
    {
        $this->onAreWeLogged();

        $idPostu = mlSecurePost("Id");
        if( !$idPostu ) return;

        $table = $this->ado->getSnapView( "vwInscripciones", "Id=$idPostu" );
        if( $table->num_rows() == 1 )
        {
            $row = $table->row();

            $porciones = explode(", ", $row->DatosPers );
            $Apellidos = $porciones[0];
            $Nombres   = $porciones[1];

            echo "new Array( $row->Id, \"$row->DNI\", \"$Apellidos\", \"$Nombres\", \"$row->IdGrupo\" )";
        }
    }

    // invocado por JS DOM Agrega Personas a CERTs
    function javaBuscape()
    {
        $this->onAreWeLogged();

        $dni = mlSecurePost("dni");
        $ape = mlSecurePost("ape");

        $table = $this->ado->getSnapView( "Personas", "DNI='$dni'" );
        if( $ape )
            $table = $this->ado->getSnapView( "Personas", "Apellidos LIKE '%$ape%'" );

        if( $table->num_rows() >= 1 )
        {
            $row = $table->row();
            echo "new Array( $row->Id, \"$row->Apellidos\", \"$row->Nombres\" )";
            exit;
        }

        echo "new Array( 0, \"\", \"\" )";
    }

    // invocado por JS DOM Asistencias
    function javaAsistio()
    {
        $this->onAreWeLogged();

        $inscr = mlSecurePost("inscr");
        $horar = mlSecurePost("horar");
        if( !$horar or !$inscr ) return;

        $filter = array( 'IdHorario'=>$horar, 'IdInscrip'=>$inscr );
        $table  = $this->ado->getTable('Asistencias', $filter );
        if( $table->num_rows() >= 1 ) {
            $this->ado->db->delete( 'Asistencias', $filter );
            echo "killed";
        } else {
            $this->ado->Insert( 'Asistencias', array(
                'IdHorario' => $horar,
                'IdInscrip' => $inscr,
                'Fecha'     => mlCurrentDate()
            ));
            echo "regs";
        }
    }

    //------------------------------------------------------------------------------
    //------------------------------------------------------------------------------
    public function login()
    {
        $user = mlSecureRequest("user");
        $pass = mlSecureRequest("pass");

        $accepted  = false;
        $userlevel = 0;

    	  // $config['encryption_key'] = 'C8t9bDDomXJrp8xvU';
    	  if( $user=="admin" && $pass=="admin" )       $accepted = true;
        if( $user=="control" && $pass=="vri123vri" ) $accepted = true;

        if( $accepted )
        {
            if( $user=="control" ) $userlevel = 6;

            mlSetGlobalVar( "cursos_admin", array(
                'username' => 'Curso/Eventos-VRI',
                'leveladm' => $userlevel,
                'loggedin' => TRUE
            ) );

            if( $userlevel == 6 )
                redirect( 'admin/asists', 'refresh' );

            redirect( 'admin/verPanel', 'refresh' );
    	}
        else
    	    //redirect(base_url().'admin', 'refresh' );
            redirect( 'admin', 'refresh' );
    }

    public function logout()
    {
        /*
        $this->session->sess_destroy();
        redirect( base_url('admin'), 'refresh');
        */
        if( !empty($_SESSION) ) {
            session_unset();
            session_destroy();
	} else {
            mlSetGlobalVar( "cursos_admin", array() );
        }
        redirect( base_url('admin'), 'refresh');
    }

    function onAreWeLogged()
    {
        $sess_data = mlGetGlobalVar( "cursos_admin" );
        if( ! $sess_data ) {
            redirect( base_url('admin'), 'refresh');
            echo "Session: Not allowed"; 
            return null;
        }
        return $sess_data;
    }
}


/*

public function login()
    {
        $user = mlSecureRequest("user");
        $pass = mlSecureRequest("pass");

    	// $config['encryption_key'] = 'C8t9bDDomXJrp8xvU';
    	if( $user=="boss" && $pass=="Eventos+" )
        {
            $this->session->set_userdata( "welogged", array(
                'username' => 'Curso/Eventos-VRI',
                'loggedin' => TRUE
            ) );
            redirect(base_url().'admin/verPanel', 'refresh' );
    	}
        else
    	    redirect(base_url().'admin', 'refresh' );
    }

    public function logout()
    {
	    $this->session->sess_destroy();
	    redirect(base_url().'admin', 'refresh');
    }

    function onAreWeLogged()
    {
		if( ! $this->session->userdata('welogged') )
            redirect(base_url().'admin', 'refresh');
    }

*/
