<?PHP  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
//------------------------------------------------------------------------------

// function evento : Manejar Eventos Personalizados
// 26 de Julio 2016

include( "../mlLibrary.php" );


class Home extends CI_Controller {

    public function __construct()
    {
        parent::__construct();
        $this->load->model("ado");
    }
    //-------------------------------------------------------------------------
    public function index()
    {
        $this->webPortada();
        //$this->webManten();
        //$qr = mlSecureRequest( "qr" );
        //echo "<h1><br><br> $qr </h1>";
    }
    //-------------------------------------------------------------------------
    public function evento( $nombevento=null )
    {
        if( $nombevento == null ) return;
        if( $nombevento == "mami" ) $nombevento="";

        $tblEventos = $this->ado->getSnapView("Eventos", "Alias='$nombevento'" );
        $resExitoso = ($tblEventos->num_rows()==1)? true : false;
        if( ! $resExitoso )
            $tblEventos = $this->ado->getSnapView("Eventos", "Alias<>'' AND Activo=1 ORDER BY Id DESC" );


        //---------------------------------------------------------------------
        // area de recuperacion de datos para registro por DNI
        //---------------------------------------------------------------------
        $eldni = mlSecureRequest( "eldni", 0 );
        $event = $tblEventos->row()->Id;

        // verificar integridad
        $eldni = (strlen($eldni)<=10)? $eldni : "0";

        $table = $this->ado->getSnapView('Eventos', "Id=$event AND Activo=1");
        $row = $table->row();
        //---------------------------------------------------------------------
        // 1. Buscar en repositorio de eventos
        //---------------------------------------------------------------------
            $personas = $this->ado->getSnapView('Personas',"DNI='$eldni'");

            if( $personas->num_rows() == 0 )
                // 2. Buscar en repositorio general Docentes
                $tempdata = $this->ado->reposDocenteAsRow( "DNI='$eldni'" );
            else
                // 3. Vacio o 1 Registro enviar
                $tempdata = $personas->row();
        //---------------------------------------------------------------------


        $this->load->view( "evsHead", array(
                // datos CMS
                'resExitoso' => $resExitoso,
                'tblEventos' => $tblEventos,

                // datos Inscripciones
                'event' => $event,
                'eldni' => $eldni,
                'EsGratis'  => $row->Gratis,
                'rowDatos'  => $tempdata,
                'DoSearch'  => (!$eldni && !$tempdata)? TRUE : FALSE,
                'tblProcd'  => $this->ado->getSnapView('Genotipo', $row->Filtro ),
                'tblGrupo'  => $this->ado->getSnapView('vwGrupos', "IdEvento = $event" ),
                'tblCarer'  => $this->ado->reposSnapView('dicCarreras', null, 'ORDER BY Nombre'),
                'tblInscr'  => $this->ado->getSnapView('vwInscripciones',"IdEvento=$event AND DNI='$eldni'")
            )   );
    }
    //-------------------------------------------------------------------------
    function inEventos( $activos, $pasados )
    {
        //--------------------------
        $arg = array(
            'verActivos' => $activos,
            'verPasados' => $pasados,
            'tblEventAct' => $this->ado->getSnapView('Eventos', 'Activo=1 AND Alias=""', 'ORDER BY Id DESC'),
            'tblEventPas' => $this->ado->getSnapView('Eventos', 'Activo=0 AND Alias=""', 'ORDER BY Id DESC')
        );

        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view("pagInicio", $arg );
        $this->load->view("webFoot");
    }
    //-------------------------------------------------------------------------
    function webManten()
    {
        echo "<h3>Estamos configurando los cursos, fechas y Repositorio de Docentes, esperenos hasta el 21 de Marzo.</h3>";
    }
    
    function webPortada()
    {
        $this->inEventos( true, true );
    }

    function evenActivos()
    {
        $this->inEventos( true, false );
    }

    function evenPasados()
    {
        $this->inEventos( false, true );
    }    
}
