<?PHP  if ( ! defined('BASEPATH')) exit('No direct script access allowed');
//------------------------------------------------------------------------------

include( "../mlLibrary.php" );


class Registro extends CI_Controller {

    public function __construct()
    {
        parent::__construct();
        $this->load->model("ado");
        $this->load->library("email");
    }
    //--------------------------------------------------------------------------
    public function index() { }
    //--------------------------------------------------------------------------
    public function in()
    {
        $event = mlSecureRequest("event",0);
        $eldni = mlSecureRequest("eldni",0);
        $peeak = isset($_GET['rsa'])? true : false;

        if( $peeak==false && strlen($eldni) != 8 ){
            $this->mlShowError( "El DNI ingresado no es válido" );
            return;
        }

        if( $event == null )
            redirect( base_url() );




        // 0. Verificar que el evento este activo
        $table = $this->ado->getSnapView('Eventos', "Id=$event AND Activo=1");

        if( $table->num_rows() == 1 ){

            // 1. Buscar en repositorio de eventos
            $personas = $this->ado->getSnapView('Personas',"DNI='$eldni'");
            $tempdata = $personas->row();
            /*
            if( $personas->num_rows() == 0 )
                // 2. Buscar en repositorio general Docentes
                $tempdata = $this->ado->reposDocenteAsRow( "DNI='$eldni'" );
            else
                // 3. Vacio o 1 Registro enviar
                $tempdata = $personas->row();
            */


            //$tblGrupoEvento = 
            //if( $event == 15 )
            //    $tblGrupoEvento = $this->ado->getSnapView('vwGrupos', "IdEvento = $event", "ORDER BY Id DESC" );

            $row = $table->row();
            $arg = array(
                'DoSearch' => $peeak,
                'event'    => $event,
                'rowDatos' => $tempdata,
                'EsGratis' => $row->Gratis,
                'FechaCur' => $row->Fecha,
                'TitulCur' => $row->Titulo,
                'tblProcd' => $this->ado->getSnapView('Genotipo', $row->Filtro ),
                'tblGrupo' => $this->ado->getSnapView('Grupos', "IdEvento = $event" ),
                'tblCarer' => $this->ado->getSnapView('dicCarreras', null, 'ORDER BY Nombre'),
                'tblInscr' => $this->ado->getSnapView('vwInscritos',"IdEvento=$event AND DNI='$eldni'")
            );

            //  02388105
            //  01304689 Nyr

            $this->load->view("webHead");
            $this->load->view("webLogo");
            $this->load->view("pagInscrip",$arg);
            $this->load->view("webFoot");
        }
        else
            redirect( base_url() );
    }
    //--------------------------------------------------------------------------
    public function out()
    {
        $event = mlSecureRequest("event");
        $eldni = mlSecureRequest("eldni");

        $verify = mlSecureRequest("captcha");
        $nombre = mlSecureRequest("nombre");
        $apells = mlSecureRequest("apells");
        $correo = mlSecureRequest("correo");
        $celula = mlSecureRequest("celula");

        $proced = mlSecureRequest("proced");
        $carrer = mlSecureRequest("carrer");
        $grupos = mlSecureRequest("grupos");
        $extras = mlSecureRequest("extras", "-" );

        $nombre      = ucwords( strtolower($nombre) );
        $apells      = mb_strtoupper( $apells );
        $fechaActual = date('Y-m-d H:i:s');
        $idPers      = 0;

        //echo "dni: $eldni";
        //return;

        //-------------------------------------------------------------------
        // 1. Verifica evento Activo
        //-------------------------------------------------------------------
        $eventos = $this->ado->getSnapView('Eventos', "Id=$event AND Activo=1");

        if( $eventos->num_rows() == 0 ){
            $this->mlShowError( "El Evento no está activo o no existe" );
            return;
        }
        $rowEvent = $eventos->row();


        //-------------------------------------------------------------------
        // 2. Verifica el Captcha
        //-------------------------------------------------------------------
        session_start();
        if( $_SESSION['capCifra'] != $verify ) {

            $this->mlShowError(
                "El codigo <b>$verify</b> no coincide con el <b>captcha</b>"
            );
            return;
        }

        //-------------------------------------------------------------------
        // 3. revisar el DNI
        //-------------------------------------------------------------------
        $personas = $this->ado->getSnapView('Personas',"DNI='$eldni'");
        $row = $personas->row();
        if( $row != null ) $idPers = $row->Id;

        //-------------------------------------------------------------------
        // 4. verificar inscripcion previa
        //-------------------------------------------------------------------
        $inscrip = $this->ado->getSnapView('Inscritos',"IdEvento=$event AND IdPersona=$idPers");
        if( $inscrip->num_rows() >= 1 ) {
            $this->mlShowError( "Sus datos fueron registrados anteriormente para el presente <b>Evento</b>" );
            return;
        }

        //-------------------------------------------------------------------
        // 5. Insertar al no estar en Repo
        //-------------------------------------------------------------------
        if( $personas->num_rows() == 0 ) {

            $idPers = $this->ado->Insert( "Personas", array(
                'DNI'       => $eldni,
                'Apellidos' => $apells,
                'Nombres'   => $nombre,
                'Telefono'  => $celula,
                'Correo'    => $correo,
                'IdTipo'    => $proced,
                'IdCarrera' => $carrer,
                'Extra'     => $extras,
                'FechaReg'  => $fechaActual,
            ));

            //$idPers = $this->ado->insert_id(); //mysqli_insert_id();
        } else {
            // actualizar correo y Telefono
            $this->ado->Update( "Personas", array(
                'Telefono'  => $celula,
                'Correo'    => $correo
            ), $idPers );
        }

        //-------------------------------------------------------------------
        // 6. Verifica las vacantes del grupo
        //-------------------------------------------------------------------
        $tgrupo = $this->ado->getSnapView('Grupos',"Id=$grupos");
        $row = $tgrupo->row();
        /*
        if( $row->Inscritos >= $row->Vacantes ){
            $this->mlShowError( "Lo sentimos, pero ya no quedan vacantes" );
            return;
        }*/

        $this->ado->Insert( "Inscritos", array(
            'IdEvento'  => $event,
            'IdGrupo'   => $grupos,
            'IdPersona' => $idPers,
            'DNI'       => $eldni,
            'Voucher'   => '*',
            'Activo'    => $rowEvent->Gratis,
            'FechaReg'  => $fechaActual,
            'IdTipo'    => $proced,
            'IdCarr'    => $carrer
        ));

        if( ! $rowEvent->Gratis ) {
            $this->mlShowSucces (
                "<br><b>Reserva éxitosa.</b><br>Debe Apersonarse al VRI y confirmar su registro y pago.",
                "registro/in?event=$event&rsa"
            );
            return;
        }


        //------------------------------------------------------------
        // cuando todo transcurrio normalmente
        //------------------------------------------------------------
        $mensaje = "<h2>Saludos<br></h2>" .
                   "Esta es la confirmación de su Inscripción en " .
                   "la Plataforma de <b>Cursos y Eventos VRI</b>. <br><br>" .
                   "Me he Inscrito en : <b> $rowEvent->Titulo </b><br>".
                   "Fecha de Registro : <b> $fechaActual  </b><br><br>";

        $this->mlSendMail  ( $correo, $mensaje );
        $this->mlShowSucces( $mensaje."email: <b>$correo</b>", "registro/in?event=$event&rsa" );
    }
    //--------------------------------------------------------------------------
    public function repAsists() // estadisticas
    {
        $event = mlSecureRequest("event");
        $table = $this->ado->getSnapView('Eventos', "Id=$event");
        $row = $table->row();

        if( $table->num_rows() == 0 ){
            redirect(base_url());
        }

        $arg = array(
            'nombEvent' => $row->Titulo,
            'tCarreras' => $this->ado->reposSnapView('dicCarreras'),
            'tRepAsist' => $this->ado->getSnapView('vwRepAsistens', "IdEvento=$event"),
        );

        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view("pagRepasis", $arg );
        $this->load->view("webFoot");
    }






    //-------------------------------------------------------------------------- --
    // dos eventos que seran internos. seran invocados solo por Admin en modo POST.
    //-------------------------------------------------------------------------- --
    function regConfirm()
    {
        $idInscrip = mlSecurePost( "idInsc" );
        $voucher   = mlSecurePost( "voucher" );
        $message   = mlSecurePost( "message" );
        if( ! $idInscrip ) return;
        //------------------------------------------
        $fechaHoy  = date('Y-m-d H:i:s');
        $table     = $this->ado->getSnapView('vwInscripciones', "Id=$idInscrip");
        $row       = $table->row();

        $this->ado->Update( "Inscritos", array(
                'Activo'    => 1,
                'Voucher'   => $voucher,
                'FechaReg'  => $fechaHoy
            ), $idInscrip );

        $mensaje   = "<h2>Saludos<br></h2>".
                     "Su reserva previa ha sido validada en Cursos y Eventos.<br><br>" .
                     "Me he Inscrito en : <b> $row->Titulo </b><br>".
                     "Fecha de Registro : <b> $fechaHoy  </b><br><br>";

        $this->mlSendMail( $row->Correo, $mensaje );
        $this->mlShowSucces( $mensaje."email: <b>$row->Correo</b>", "admin/listar" );
    }
    //--------------------------------------------------------------------------
    function regReject()
    {
        $idInscrip = mlSecurePost( "idInscx" );
        $message   = mlSecurePost( "messagex" );
        if( ! $idInscrip ) return;
        //------------------------------------------
        $table = $this->ado->getSnapView('vwInscripciones', "Id=$idInscrip");
        $row   = $table->row();

        $this->ado->db->delete( "Inscritos", array('Id'=>$idInscrip) );
        if( strlen($message) ){
            $this->mlSendMail( $row->Correo, $message."<br>Curso: $row->Titulo <br><br>" );
        } else
            $message = "Registro eliminado sin notificación";

        $this->mlShowSucces( $message."<br><br>email: <b>$row->Correo</b>", "admin/listar" );
    }
    //--------------------------------------------------------------------------
    function busquedas()
    {
        $this->load->model("ado");

        $eldni = mlSecureRequest("eldni",0);

        $arg = array(
            'tcertis' => $this->ado->getSnapView( "vwCertificas", "DNI=$eldni" )
        );

        $this->load->view("webHead");
        $this->load->view("webLogo");
        $this->load->view( "pagBusqs", $arg );
        $this->load->view("webFoot");
    }




    //--------------------------------------------------------------------------
    // function Captcha: debe ser desplegado como pagina en un <IFRAME>
    //--------------------------------------------------------------------------
    public function doCaptcha()
    {
        $cifra  = '';
        $lenght = 3;

        $imagex = @imagecreatetruecolor(150, 40) or die("Cannot Initialize new GD image stream");
        imagefill( $imagex, 0, 0, imagecolorallocate($imagex, 0x30, 0x55, 0x30) );

        $color1 = imagecolorallocate($imagex, 0xF3, 0x92, 0x30);
        $color2 = imagecolorallocate($imagex, 0xFF, 0xFF, 0xFF);
        $color3 = imagecolorallocate($imagex, 0x25, 0xA0, 0x25);

        for($i=3; $i<50; $i+=5 ) imageline($imagex, 0, $i, 160, $i, $color3 );
        for( $i=0; $i<$lenght; $i++ ) {
            $color  = (rand() % 2) ? $color1 : $color2;
            $cifra .= ($num = rand(0, 9));
            imagechar($imagex, rand(4, 7), 25+($i*35), rand(5, 16), $num, $color );
        }
        session_start();
        $_SESSION['capCifra'] = $cifra;

        header("Content-type: image/png");
        imagepng( $imagex );
        imagedestroy( $imagex );
        ///echo "<img src='data:image/png;base64," .base64_encode( ob_get_clean() ). ">" ;
    }

    //-----------------------------------------------------------------------------------------
    function mlSendMail( $destino, $mensaje ){

        $titulo  = 'Inscripcion en Cursos y Eventos VRI';
        $mensaje = base64url_encode( $mensaje );
        ?>
        <script src="<?=base_url()?>includefile/lightajax.js"></script>
        <script src="<?=base_url()?>includefile/eventos.js"></script>
        <!-- area de Ajax VRI -->
        <script>
            jVRI.ajax({
                url  : "<?=base_url()?>includefile/maileventos.php",
                data : "x=<?=$destino?>&y=<?=$titulo?>&z=<?=$mensaje?>&k=1",
                success: function( res ){
                    //alert( res );
                }
            });
        </script>
        <?php
    }

    function mlShowError( $message )
    {
        $arg = array(
            'errorDlg'   => true,
            'strMensaje' => $message,
            'strTitulo'  => "Error Procesando",
            'event'      => "history.back()"
        );

        $this->load->view("showMessage", $arg );
    }

    function mlShowSucces( $message, $tourl=null )
    {
        $this->load->view("showMessage", array(
            'errorDlg'   => false,
            'strMensaje' => $message,
            'strTitulo'  => "Operación Exitosa",
            'event'      => "location.href='" . base_url() . $tourl. "'"
        ) );
    }
}