<?php
    echo "Uncertain view!";
    exit;
?>

-- --------------------------------------------
-- 1. Vista Grupos  [OK usado]
-- --------------------------------------------
CREATE VIEW vwGrupos AS
SELECT  G.Id, G.IdEvento, G.Activo, G.Nombre AS NombGrupo, G.Vacantes,
        (SELECT count(*) FROM Inscritos WHERE Activo=1 AND IdGrupo=G.Id ) AS Inscritos,
        CONCAT(G.Nombre,' - ( ',(SELECT count(*) FROM Inscritos WHERE Activo=1 AND IdGrupo=G.Id),' de ',G.Vacantes,' )') AS NombVacan,
        E.Titulo AS NombEvento
  FROM Grupos AS G,
       Eventos AS E
 WHERE E.Id=G.IdEvento
 ORDER BY Id
;



-- --------------------------------------------
-- 2. Vista Inscritos activo/no  [OK usando]
-- --------------------------------------------
CREATE VIEW vwInscripciones AS
SELECT I.Id, I.IdEvento, P.Id AS IdPersona, I.Activo, P.DNI,
       CONCAT( P.Apellidos,', ',P.Nombres ) AS DatosPers,
       I.IdGrupo, G.Nombre AS Grupo, I.Voucher, P.IdProced,
       P.IdCarrera, I.FechaReg, P.Correo, E.Titulo,
       (SELECT CodigoVRI FROM Certificados WHERE IdEvento=E.Id AND IdInscrip=I.Id AND IdPersona=P.Id LIMIT 1) AS Certi
  FROM Inscritos  AS  I,
       Personas   AS  P,
       Grupos     AS  G,
       Eventos    AS  E
 WHERE P.Id = I.IdPersona
   AND G.Id = I.IdGrupo
   AND E.Id = I.IdEvento
ORDER BY I.IdEvento DESC, I.IdGrupo, I.Id DESC
;



-- --------------------------------------------
-- 3. Vista Asistencias a Marcar  [OK usando]
-- Se crea sin cruce multiplicando Horarios
-- por la cantidad de Inscritos Activos
-- --------------------------------------------
CREATE VIEW vwMarcarAsistens AS
SELECT  H.Id as IdHorario, H.Activo, H.IdEvento, I.IdGrupo, I.IdPersona,
        I.Id as IdInscrip, H.Nombre as Horario, I.DNI,
        P.IdProced, P.IdCarrera,
        CONCAT(P.Apellidos,', ',P.Nombres) AS DatosPers,
        (SELECT COUNT(*) FROM Asistencias WHERE IdHorario=H.Id AND IdInscrip=I.Id) AS Asistencia
  FROM  Horarios  AS H,
        Inscritos AS I,
        Personas  AS P
 WHERE  I.IdEvento  = H.IdEvento
   AND  I.IdPersona = P.Id
   AND  I.Activo    = 1
ORDER BY I.IdEvento DESC, I.IdGrupo, H.Id, DatosPers
;



-- -----------------------------------------------------------------------------
-- 4. Vista Asistencias [antes de los certificados] OK
-- -----------------------------------------------------------------------------
CREATE VIEW vwRepAsistencias AS
SELECT VA.IdEvento, VA.IdGrupo, VA.IdPersona, VA.IdInscrip, VA.DNI, 
       VA.IdProced, VA.IdCarrera, VA.DatosPers,
       SUM(IF(VA.Asistencia=1,1,0)) as Asistencias,
       COUNT(*) as TotalAsistir,
       ROUND((SUM(IF(VA.Asistencia=1,1,0)) / COUNT(*)) * 100) as Porcentaje,
       (SELECT CodigoVRI FROM Certificados WHERE VA.IdEvento=IdEvento AND VA.IdPersona=IdPersona AND VA.IdInscrip=IdInscrip AND Tipo=1 LIMIT 1) AS Certi
  FROM vwMarcarAsistens as VA
GROUP BY VA.IdEvento DESC, VA.IdGrupo, VA.DatosPers
ORDER BY VA.IdEvento DESC, VA.IdGrupo, VA.DatosPers
;




-- -----------------------------------------------------------------------------
-- 5. Vista Reportes y Estadisticas de Asist por Evento y Carrera  [OK usando]
-- -----------------------------------------------------------------------------
CREATE VIEW vwRepAsistens AS
SELECT I.IdEvento, P.IdCarrera,
       count(P.IdCarrera) AS Inscritos,
       SUM(IF( (SELECT count(*) FROM Asistencias WHERE IdInscrip=I.Id)>=1, 1, 0)) AS Asistentes
  FROM Inscritos   AS  I,
       Personas    AS  P
 WHERE P.Id = I.IdPersona
GROUP BY I.IdEvento, P.IdCarrera
ORDER BY I.IdEvento DESC, P.IdCarrera
;


-- -----------------------------------------------------------------------------
-- 6. Vista Certificados.
-- -----------------------------------------------------------------------------
CREATE VIEW vwCertificados AS
SELECT C.Id as IdCerti, C.IdEvento, C.CodigoVRI as Codigo,
       ( SELECT IdGrupo FROM Inscritos WHERE IdPersona=P.Id AND IdEvento=C.IdEvento LIMIT 1) AS IdGrupo,
       C.Orden, C.Tipo as TipoCerti, C.MiniCur, P.IdCarrera, T.Nombre as Modalidad,
       P.IdProced, P.DNI, P.Grado, UCASE(CONCAT(P.Nombres,' ',P.Apellidos)) AS DatosPers, C.Fecha,
       E.Titulo AS NombEvento
  FROM Certificados AS  C,
       tipoCertis   AS  T,
       Personas     AS  P,
       Eventos      AS  E
 WHERE P.Id = C.IdPersona
   AND T.Id = C.Tipo
   AND E.Id = C.IdEvento
ORDER BY C.IdEvento DESC, C.Orden
;




-- View Asistencias por Carreras



--- fin



    
    
    
    
    
    
    
    
    
    
    





CREATE VIEW vwAsistencias AS
SELECT A.Id AS IdAsist, A.IdHorario, A.Fecha, I.IdEvento, I.IdGrupo,
       P.IdProced, P.IdCarrera, P.Apellidos, P.Nombres
  FROM Asistencias AS  A,
       Inscritos   AS  I,
       Personas    AS  P
 WHERE I.Id = A.IdInscrip
   AND P.Id = I.IdPersona
ORDER BY I.IdEvento DESC, I.IdGrupo, P.IdProced, P.IdCarrera


-- ----------------------------------------------------------
-- 
-- ----------------------------------------------------------
CREATE VIEW vwEstadAsistens AS
SELECT P.IdCarrera, V.IdEvento,
       COUNT(*) AS Inscritos, SUM(IF(Asistencia>=1,1,0)) AS Asistentes
  FROM vwMarcarAsistens  AS V,
       Personas AS P
 WHERE P.Id = V.IdPersona
 GROUP BY V.IdEvento, P.IdCarrera ASC



    
SELECT V.IdEvento, V.IdCarrera,
       COUNT(*) AS Inscritos
 FROM  vwInscripciones AS V
GROUP  BY V.IdEvento, V.IdCarrera
ORDER  BY V.IdEvento DESC, V.IdCarrera
    
    
    
    
    
    


-- ----------------------------------------
SELECT  *
  FROM  Horarios   AS  H,
        Inscritos  AS  I
 WHERE  I.IdEvento = 3
   AND  H.IdEvento = 3

SELECT * 
FROM Horarios AS H, Inscritos AS I
WHERE I.IdEvento = H.IdEvento
-- ----------------------------------------




-- --------------------------------------------
-- 2. Vista Asistentes Habiles
-- --------------------------------------------
CREATE VIEW vwAsistencias AS
SELECT A.Id, A.IdEvento, A.IdHorario, H.Nombre AS Horario,
       P.Id AS IdPersona, P.DNI,
       CONCAT( P.Apellidos,', ',P.Nombres ) AS DatosPers,
       P.IdProced, P.IdCarrera, A.Fecha AS FechaAsist
  FROM Asistencias  AS  A,
       Personas     AS  P,
       Horarios     AS  H
 WHERE P.Id = A.IdPersona
   AND H.Id = A.IdHorario
ORDER BY  A.IdEvento, A.IdHorario, P.IdCarrera, P.IdProced, DatosPers, A.Id
;


-- --------------------------------------------
-- 3. Vista Asistentes Habiles
-- --------------------------------------------
CREATE VIEW vwAsistencReal AS
SELECT *, count(*) AS Asistencias FROM vwAsistencias GROUP BY IdEvento, IdPersona
;




